/* screen.h - header for terminal package
 * Assumes ANSI terminal
 */
#ifndef SCREEN_H
#define SCREEN_H

typedef short SCR_CMDCHAR;
#define SCR_RETURN '\r'
#define SCR_EXIT   0x101
#define SCR_UP     0x102
#define SCR_DOWN   0x103
#define SCR_LEFT   0x104
#define SCR_RIGHT  0x105
#define SCR_HOME   0x106
#define SCR_CLEAR  "\33[2J"		/* clear entire screen, go HOME */
#define SCR_CEL    "\33[K"		/* clear to end of line */
#define SCR_TTY 1	/* screen is in ordinary (non-direct) mode */
#define SCR_RAW 2	/* screen is in "total-control" mode */

#define SCR_CMD(c) \
	(c == SCR_RETURN || c >= 0x101 && c <= 0x106)

extern short scr_mode;		/* {SCR_TTY, SCR_RAW} */
extern short scr_lins;		/* number of lines on screen */
extern short scr_cols;		/* number of columns on screen */

void scr_close();			/* PARMS(void) */
SCR_CMDCHAR scr_getkey();	/* PARMS(void) */
void scr_open();			/* PARMS(void) */

#define scr_beep()		putchar('\7')
#define scr_clear()		printf(SCR_CLEAR)
#define scr_cel()		printf(SCR_CEL)
#define scr_curs(r, c)	printf("\33[%d;%dH", (r)+1, (c)+1)
#define scr_print		printf
#define scr_putc(c)		putchar(c)
#define scr_refresh()	fflush(stdout)
#endif
